﻿using System;
using System.Collections.Generic;
using System.Data;
using System.IO;
using System.Linq;
using System.Text;
// Jay (the Ham) Harland

namespace MuramasaTDB_Encoding
{
    /*
     * Decodes the file whose path is defined in textBoxFilePath.Text (Not defined here)
     * Write the decoded file to disc at textBoxFilePath.Text + "_decomp"
     */
    private void decodeFile()
    {
        FileStream loader = new FileStream(textBoxFilePath.Text, FileMode.Open);

        byte[] inputFile = new byte[loader.Length];

        loader.Read(inputFile, 0, inputFile.Length);
        loader.Close();

        int outputSize = inputFile[4] + (inputFile[5] << 8) + (inputFile[6] << 16) + (inputFile[7] << 24);

        byte[] outputFile = new byte[outputSize + 0x1000];

        int inputPosition = 0xC;
        int outputPosition = 0;
        int byteNum = 8;
        byte control = 0;

        while (inputPosition < inputFile.Length)
        {
            if (byteNum == 8) //If control byte
            {
                byteNum = 0;

                control = inputFile[inputPosition];

                inputPosition++;
            }
            else if (((control >> byteNum) & 0x01) == 1) //If this is a normal byte
            {
                outputFile[outputPosition] = inputFile[inputPosition];
                outputPosition++;
                inputPosition++;
            }
            else //This is a compressed data referer, 2 bytes
            {
                byte referer1 = inputFile[inputPosition];
                inputPosition++;
                byte referer2 = inputFile[inputPosition];
                inputPosition++;

                int numBytesToCopy = (referer2 & 0x0f) + 3;
                int distance = (referer1 + ((referer2 & 0xf0) << 4)) + 0x12;

                while ((outputPosition - distance) > 0x1000)
                    distance += 0x1000;

                while (numBytesToCopy != 0)
                {
                    outputFile[outputPosition] = outputFile[distance];
                    distance++;
                    outputPosition++;

                    //distance = distance & 0xFFF; needed?
                    numBytesToCopy--;
                }
            }
            byteNum++;
        }

        string outputFilePath = textBoxFilePath.Text + "_decomp";
        FileStream writer = new FileStream(outputFilePath, FileMode.Create);
        writer.Write(outputFile, 0, outputSize);
        writer.Flush();
        writer.Close();
    }
}
